local guildOnline = {};
_G.guildOnline = guildOnline;
guildOnline = _class.regiest();

local vars_loaded = false;
local guild_ranks = {}
local rank_colors = {}
local ranks_loaded = false;
local colors_loaded = false;
local sort_loaded = false;
local float_sort_loaded = false;
local float_info_loaded = false;
local color_list = {};
local color_rgb = {};
local go_guild_members = nil;
local go_guild_frame_shown = false;
local go_guild_tick_count = 0;
local go_guild_num_members = 0;
local go_guild_num_online = 0;
local go_guild_update_timer = 0;
local go_guild_load_completed = false;
local go_guild_loading = false;
local go_guild_online_members = nil;
local go_guild_online_has_shown = false;
local go_guild_online_guild_frame_hidden = false;
local go_guild_error_thrown = false;

function guO_easy_echo(outstr)
   DEFAULT_CHAT_FRAME:AddMessage(outstr)
end

function guO_colored_echo(outstr,r,g,b)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(outstr, r,g,b);
	end
end

local old_GuildFrame_OnShow = GuildFrame_OnShow;
local old_GuildFrame_OnHide = GuildFrame_OnHide;

function TGuildFrame:SetSelection(Button)
	local MemberID=0;
	local MemberName="";
	
	if (Button~=nil) then	
		local Name=getglobal(Button:GetName().."Name");
		if (string.find(Name:GetText(), "\r\n") ~= nil) then
			MemberName = string.sub(Name:GetText(), 1, string.find(Name:GetText(), "\r\n") - 1);
		else
			MemberName = Name:GetText();
		end
		MemberID=Button.id;
	
		local SelctBar=getglobal(Button:GetName().."_Checked");
	
		if (self.SelctBar~=nil) then
			self.SelctBar:Hide();
		end
		self.SelctBar=SelctBar;
		SelctBar:Show();
	end
	self.slectedGuildMember = MemberID ;
	self.selectedName = MemberName;
	SetGuildRosterSelection(MemberID);
end

function GuildFrame_OnHide(this)
	guildOnline_FloatFrame:Hide();
	old_GuildFrame_OnHide(this);
end

function GuildFrame_OnShow(this)
	GuildWarButton:ClearAllAnchors();
	GuildWarButton:SetAnchor("TOPLEFT", "TOPLEFT", "GuildFrame", 28, 62)
	go_guild_frame_shown = true;
	go_guild_online_has_shown = true;
	old_GuildFrame_OnShow(this);
	if (guildOnline_data.ShowSort == nil or guildOnline_data.ShowSort == true) then
		guildOnline_FloatFrame:Show(); 
		guildOnline_OnlineStats:ClearAllAnchors();
		guildOnline_OnlineStats:SetAnchor("TOPLEFT", "TOPLEFT", "GuildFrame", 28, 45);
    else  
		guildOnline_FloatFrame:Hide(); 
		guildOnline_OnlineStats:ClearAllAnchors();
		guildOnline_OnlineStats:SetAnchor("TOPLEFT", "TOPLEFT", "GuildFrame", 28, 45); 
	end
end

function guildOnline_LoadTimes()
	if (go_guild_frame_shown or go_guild_tick_count == 0) then
		go_guild_frame_shown = false;
		local cur_tick_count = GetTickCount();
		if (cur_tick_count - go_guild_tick_count > 10000 and not go_guild_loading) then
			if (not vars_loaded) then
				local curLocal = string.sub(GetLocation(), 1, 2);
		
				if (string.upper(curLocal) == "EN" or string.upper(curLocal) == "DE") then
					dofile("Interface/AddOns/guildOnline/Locales/guildOnline."..string.upper(curLocal)..".lua");
				else
					dofile("Interface/AddOns/guildOnline/Locales/guildOnline.EN.lua");
				end
			end
			go_guild_loading = true;
			local numGuildNodes = GetNumGuildMembers();
			go_guild_tick_count = GetTickCount();
			go_guild_members = {};
			local load_online = false;
			if (go_guild_online_members == nil) then
				go_guild_online_members = {};
				load_online = true;
			end
			local index = 1;
			go_guild_num_online = 0;
			
			while (index <= numGuildNodes) do
				SetGuildRosterSelection(index);
				
				name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle,IsOnLine ,LogOutTime,Zone,Note=GetGuildRosterInfo(index);
				
				tObj = {};
				tObj[1] = name;
				tObj[2] = rank;
				tObj[3] = class;
				tObj[4] = subClass;
				tObj[5] = index;
				tObj[7] = level;
				local months,days,hours;
				

				if (load_online) then
					if (IsOnLine == false) then
						go_guild_online_members[index] = "-";
					else					
						go_guild_online_members[index] = "+";
					end
				elseif (guildOnline_data.announceGuild) then
					if (IsOnLine == false) then
						if (go_guild_online_members[index] ~= "-") then
							go_guild_online_members[index] = "-";		
							guO_colored_echo(name..gO_Localized["Phrases"]["hasgoneoffline"], 1,0.2,0.2);	
						end
					else		
						if (go_guild_online_members[index] == "-") then
							go_guild_online_members[index] = "+";
							guO_colored_echo(name..gO_Localized["Phrases"]["hascomeonline"], 0.2,1,0.2);
						end
					end
				end
				
				if (IsOnLine == false and LogOutTime ~= nil) then
					if (string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["month"]) ~= nil) then
						arg1,arg2,months = string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["month"])
					else
						months = 0
					end 
					if (string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["day"]) ~= nil) then
						arg1,arg2,days = string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["day"])
					else
						days = 0
					end 
					
					if (string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["0hour"]) ~= nil) then
						arg1,arg2,hours = string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["0hour"])
					elseif (string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["hour"]) ~= nil) then
						arg1,arg2,hours = string.find(string.lower(LogOutTime), gO_Localized["Patterns"]["hour"])
					else
						if (string.find(string.lower(LogOutTime), '0%d:') ~= nil and string.find(string.lower(LogOutTime), '0%d:') == 1) then
							arg1,arg2,hours = string.find(string.lower(LogOutTime), '0(%d):');
						else
							arg1,arg2,hours = string.find(string.lower(LogOutTime), '(%d+):');
						end
					end
					
					if (hours == nil) then
						hours = 0;
					end				
				else
					go_guild_num_online = go_guild_num_online + 1;
					months = 0;
					days = 0;
					hours = 0;
				end
				
				days = days + (months * 30);
				tObj[6] = (days * 24) + hours;

				go_guild_members[index] = tObj;
				index = index + 1;
			end
			
			floatFrame_numOnline:SetText(go_guild_num_online.." of "..numGuildNodes.." "..gO_Localized["Phrases"]["Online"]);
		end
		
		if (go_guild_members ~= nil and guildOnline_data.guO_sort_order ~= nil and guildOnline_data.guO_sort_order > 0 and guildOnline_data.guO_sort_order ~= 5) then
			if (guildOnline_data.guO_sort_order == 1 or guildOnline_data.guO_sort_order == 3 or guildOnline_data.guO_sort_order == 4) then
				table.sort(go_guild_members, function(a, b) if (a[guildOnline_data.guO_sort_order] == nil) then return true; elseif (b[guildOnline_data.guO_sort_order] == nil) then return false; else return string.lower(a[guildOnline_data.guO_sort_order]) < string.lower(b[guildOnline_data.guO_sort_order]) end; end);
			elseif (guildOnline_data.guO_sort_order == 2 or guildOnline_data.guO_sort_order == 7) then
				table.sort(go_guild_members, function(a, b) if (a[guildOnline_data.guO_sort_order] == nil) then return false; elseif (b[guildOnline_data.guO_sort_order] == nil) then return true; else return a[guildOnline_data.guO_sort_order] > b[guildOnline_data.guO_sort_order] end; end);
			elseif (guildOnline_data.guO_sort_order == 6) then
				table.sort(go_guild_members, function(a, b) if (a[guildOnline_data.guO_sort_order] == nil) then return false; elseif (b[guildOnline_data.guO_sort_order] == nil) then return true; else return a[guildOnline_data.guO_sort_order] < b[guildOnline_data.guO_sort_order] end; end);
			elseif (guildOnline_data.guO_sort_order == 5) then
			
			else
				table.sort(go_guild_members, function(a, b) if (a[guildOnline_data.guO_sort_order] == nil) then return false; elseif (b[guildOnline_data.guO_sort_order] == nil) then return true; else return a[guildOnline_data.guO_sort_order] < b[guildOnline_data.guO_sort_order] end; end);
			end
		end
		
		go_guild_update_timer = 10;
		go_guild_loading = false;
		go_guild_load_completed = true;
	end
end

function guildOnline_SortOrder_OnLoad(this)	
	if (not sort_loaded) then
		UIDropDownMenu_SetWidth(this, 92);
		UIDropDownMenu_Initialize(this, guildOnline_SortOrder_Show);
		UIDropDownMenu_SetSelectedID(guildOnline_SortOrder, guildOnline_data.guO_sort_order);
		sort_loaded = true;
	end
end

function guildOnline_SortOrder_Float_OnLoad(this)	
	if (not float_sort_loaded) then
		UIDropDownMenu_SetWidth(this, 92);
		UIDropDownMenu_Initialize(this, guildOnline_SortOrder_Float_Show);
		UIDropDownMenu_SetSelectedID(guildOnline_SortOrder_Float, guildOnline_data.guO_sort_order);
		float_sort_loaded = true;
	end
end

function guildOnline_PlayerInfo_Float_OnLoad(this)	
	if (not float_info_loaded) then
		UIDropDownMenu_SetWidth(this, 92);
		UIDropDownMenu_Initialize(this, guildOnline_PlayerInfo_Float_Show);
		UIDropDownMenu_SetSelectedID( guildOnline_PlayerInfo_Float, guildOnline_data.guO_player_info);
		float_info_loaded = true;
	end
end

function guildOnline_GuildRanks_OnLoad(this)	
	if (not ranks_loaded) then
		UIDropDownMenu_SetWidth(this, 92);
		UIDropDownMenu_Initialize(this, guildOnline_GuildRanks_Show);
		UIDropDownMenu_SetSelectedID(guildOnline_GuildRanks, 1);
		ranks_loaded = true;
	end
end

function guildOnline_GuildRankColors_OnLoad(this)
	if (not colors_loaded) then
		UIDropDownMenu_SetWidth(this, 92);
		UIDropDownMenu_Initialize(this, guildOnline_GuildRankColors_Show);		
		UIDropDownMenu_SetSelectedID(guildOnline_GuildRankColors, guildOnline_data.rank_colors[1][1]);
		colors_loaded = true;
	end
end

function guildOnline_SortOrder_Show()
	info = {}
	info.value = 1;
	info.text = "Name";
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 2;
	info.text = gO_Localized["Phrases"]["Rank"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 3;
	info.text = gO_Localized["Phrases"]["Class"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 4;
	info.text = gO_Localized["Phrases"]["Sub-Class"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 5;
	info.text = gO_Localized["Phrases"]["Default"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 6;
	info.text = gO_Localized["Phrases"]["Last Login"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 7;
	info.text = "Level";
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
end

function guildOnline_SortOrder_Float_Show()
	info = {}
	info.value = 1;
	info.text = "Name";
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 2;
	info.text = gO_Localized["Phrases"]["Rank"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 3;
	info.text = gO_Localized["Phrases"]["Class"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 4;
	info.text = gO_Localized["Phrases"]["Sub-Class"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 5;
	info.text = gO_Localized["Phrases"]["Default"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 6;
	info.text = gO_Localized["Phrases"]["LastLogin"];
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 7;
	info.text = "Level";
	info.func = guildOnline_SortOrder_Select;
	UIDropDownMenu_AddButton(info);
end

function guildOnline_PlayerInfo_Float_Show()
	info = {}
	info.value = 1;
	info.text = gO_Localized["Phrases"]["Class"].."/"..gO_Localized["Phrases"]["Rank"].."/"..gO_Localized["Phrases"]["Online"];
	info.func = guildOnline_PlayerInfo_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 2;
	info.text = gO_Localized["Phrases"]["Class"].."/"..gO_Localized["Phrases"]["Rank"].."/"..gO_Localized["Phrases"]["Note"];
	info.func = guildOnline_PlayerInfo_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 3;
	info.text = gO_Localized["Phrases"]["Class"].."/"..gO_Localized["Phrases"]["Rank"].."/".."Zone";
	info.func = guildOnline_PlayerInfo_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 4;
	info.text = gO_Localized["Phrases"]["Rank"].."/".."Zone/"..gO_Localized["Phrases"]["Note"];
	info.func = guildOnline_PlayerInfo_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 5;
	info.text = gO_Localized["Phrases"]["Rank"].."/".."Zone/"..gO_Localized["Phrases"]["Online"];
	info.func = guildOnline_PlayerInfo_Select;
	UIDropDownMenu_AddButton(info);
	info = {}
	info.value = 6;
	info.text = "Zone/"..gO_Localized["Phrases"]["Online"].."/"..gO_Localized["Phrases"]["Note"];
	info.func = guildOnline_PlayerInfo_Select;
	UIDropDownMenu_AddButton(info);
end

function guildOnline_GuildRanks_Show()	
	local count=10;
	local info;
	
	for i=1,count do
		if (guild_ranks[i] ~= nil) then
			info = {};
			info.value = i;
			info.text = guild_ranks[i];
			info.func = guildOnline_GuildRanks_Select;
			UIDropDownMenu_AddButton(info);
		end
	end
end

function guildOnline_GuildRankColors_Show()	
	local count=15;
	local info;
	
	for i=1,count do
		if (color_list[i] ~= nil) then
			info = {};
			info.value = i;
			info.text = color_list[i][2];
			info.func = guildOnline_GuildRankColors_Select;
			UIDropDownMenu_AddButton(info);
		end
	end
end

function guildOnline_PlayerInfo_Select(button)
	guildOnline_data.guO_player_info = button.value;
	UIDropDownMenu_SetSelectedID(guildOnline_PlayerInfo_Float, button.value);	
	go_guild_frame_shown = true;
	local lObject=GuildFrame.class;lObject:GuildMemberUpDate();
end

function guildOnline_SortOrder_Select(button)
	guildOnline_data.guO_sort_order = button.value;
	UIDropDownMenu_SetSelectedID(guildOnline_SortOrder, button.value);	
	UIDropDownMenu_SetSelectedID(guildOnline_SortOrder_Float, button.value);	
	go_guild_frame_shown = true;
	local lObject=GuildFrame.class;lObject:GuildMemberUpDate();
end

function guildOnline_GuildRankColors_Select(button)
	local whichRank = UIDropDownMenu_GetSelectedID(guildOnline_GuildRanks);
	guildOnline_data.rank_colors[whichRank] = color_list[button.value];
	UIDropDownMenu_SetSelectedID(guildOnline_GuildRankColors, button.value);	
end

function guildOnline_GuildRanks_Select(button)
	UIDropDownMenu_SetSelectedID(guildOnline_GuildRanks, button.value);
	UIDropDownMenu_SetSelectedID(guildOnline_GuildRankColors, guildOnline_data.rank_colors[button.value][1]);
	UIDropDownMenu_SetText(guildOnline_GuildRankColors, guildOnline_data.rank_colors[button.value][2]);
end

function guildOnline_MIA_Point_OnEnterPressed(this)
	guildOnline_data.miaPoint = guildOnline_MIA_Point:GetText();
	guildOnline_MIA_Point:ClearFocus();
end

function guildOnline_MIA_Point_OnEscapePressed(this)
	guildOnline_MIA_Point:SetText(guildOnline_data.miaPoint);
	guildOnline_MIA_Point:ClearFocus();
end

function guildOnline_AdjustDisplay()
	local index = 1;
	
	if (guildOnline_data.customDisplay) then
		while (index <= 14) do
			GuildInformationDropDown:Hide();
			guildOnline_PlayerInfo_Float:Show();
			getglobal("GuildMemberHeader"..index):SetHeight(26);
			getglobal("GuildMemberButton"..index):SetHeight(26);
			getglobal("GuildMemberButton"..index.."Name"):SetHeight(26);
			getglobal("GuildMemberButton"..index.."Text"):SetHeight(26);
			index = index + 1;
		end
	else
		while (index <= 14) do		
			guildOnline_PlayerInfo_Float:Hide();
			GuildInformationDropDown:Show();
			getglobal("GuildMemberHeader"..index):SetHeight(16);
			getglobal("GuildMemberButton"..index):SetHeight(16);
			getglobal("GuildMemberButton"..index.."Name"):SetHeight(16);
			getglobal("GuildMemberButton"..index.."Text"):SetHeight(16);
			index = index + 1;
		end
	end
end

function TGuildFrame:SetMemberList(ListType,frame,name ,rank, mainClass ,mainLev, subClass,subLev ,tilte,IsOnline,LogoutTime,zone,Note)
	if (not go_guild_online_has_shown) then
		return;
	end
	
	local msg=getglobal(frame:GetName().."Text");
	local Name=getglobal(frame:GetName().."Name");
	
	if (guildOnline_data.customDisplay) then	
		local nameText = "";
		local textText = "";
	
		if (zone == nil or zone == "") then
			zone = gO_Localized["Phrases"]["RealWorld"];
		end
		if (Note == nil or Note == "") then
			Note = "---"
		end
		
		if (ListType == 1) then
			if (string.len(subClass)==0) then
				nameText = name.."\r\n["..mainLev.." "..mainClass.."]";
			else
				nameText = name.."\r\n["..mainLev.." "..mainClass.."/"..subLev.." "..subClass.."]";
			end
			textText = self.rankStrTab[rank].."\r\n";			
			if (IsOnline==true) then		
				textText = textText..GUILD_STR_ONLINE;
			else		    
				textText = textText..string.format("%s",string.gsub(LogoutTime,"%p%p%p$",""));
			end		
		elseif (ListType == 2) then
			if (string.len(subClass)==0) then
				nameText = name.."\r\n["..mainLev.." "..mainClass.."]";
			else
				nameText = name.."\r\n["..mainLev.." "..mainClass.."/"..subLev.." "..subClass.."]";
			end
			textText = self.rankStrTab[rank].."\r\n"..Note;
		elseif (ListType == 3) then
			if (string.len(subClass)==0) then
				nameText = name.."\r\n["..mainLev.." "..mainClass.."]";
			else
				nameText = name.."\r\n["..mainLev.." "..mainClass.."/"..subLev.." "..subClass.."]";
			end
			textText = self.rankStrTab[rank].."\r\n"..zone;
		elseif (ListType == 4) then
			nameText = name.."\r\n"..self.rankStrTab[rank];
			textText = zone.."\r\n"..Note;
		elseif (ListType == 5) then
			nameText = name.."\r\n"..self.rankStrTab[rank];
			textText = zone.."\r\n";			
			if (IsOnline==true) then		
				textText = textText..GUILD_STR_ONLINE;
			else		    
				textText = textText..string.format("%s",string.gsub(LogoutTime,"%p%p%p$",""));
			end		
		elseif (ListType == 6) then
			nameText = name.."\r\n"..zone;		
			if (IsOnline==true) then		
				textText = GUILD_STR_ONLINE.."\r\n";
			else		    
				textText = string.format("%s\r\n",string.gsub(LogoutTime,"%p%p%p$",""));
			end
			textText = textText..Note;
		else
			if (string.len(subClass)==0) then
				nameText = name.."\r\n["..mainLev.." "..mainClass.."]";
			else
				nameText = name.."\r\n["..mainLev.." "..mainClass.."/"..subLev.." "..subClass.."]";
			end
			textText = self.rankStrTab[rank].."\r\n";			
			if (IsOnline==true) then		
				textText = textText..GUILD_STR_ONLINE;
			else		    
				textText = textText..string.format("%s",string.gsub(LogoutTime,"%p%p%p$",""));
			end		
		end
		
		msg:SetText(textText);
		Name:SetText(nameText);
		
		if (IsOnline==true) then		
			Name:SetColor(0.82,0.80,0.21);
		else
			Name:SetColor(0.6,0.6,0.6);
		end
	else
		Name:SetText(name);	
		if (IsOnline==true) then		
			Name:SetColor(0.82,0.80,0.21);
		else
			Name:SetColor(0.6,0.6,0.6);
		end
			
		local str="123";
		if (ListType==1) then	
			if (string.len(subClass)==0) then
				str=string.format("%s lv%d",mainClass,mainLev);
			else
				str=string.format("%s lv%d/ %slv%d",mainClass,mainLev,subClass,subLev);			
			end	
		elseif (ListType==2) then
			 str=self.rankStrTab[rank];
		elseif (ListType==3) then	
			if (IsOnline==true) then		
				str=GUILD_STR_ONLINE;
			else		    
				str=string.format("%s %s",GUILD_STR_OFFLINE,LogoutTime);
			end		
		elseif (ListType==4) then		
			str=Note;	
		elseif (ListType==5) then	
			str=zone;		
		end
		
		msg:SetText(str);
	end
end

function TGuildFrame:GuildMemberUpDate()
	local numGuildNodes = GetNumGuildMembers();

	if (go_guild_num_members ~= numGuildNodes) then	
		go_guild_num_members = numGuildNodes;
		go_guild_frame_shown = true;
		go_guild_tick_count = 0;
	end
	
	guildOnline_LoadTimes();
	
	local name, rank, class, level, subClass, subLevel, isHeader, isCollapsed;
	local button, header;
	local index = getglobal("GuildMemberFrameScrollBar"):GetValue() + 1;	
	self.MemberCount=0;
	local ListType = UIDropDownMenu_GetSelectedID(GuildInformationDropDown);
	local shownMembers = 1;
	local bufferLines = 0;
	local maxShown = 14;	
	
	if (guildOnline_data.customDisplay) then
		GuildInformationDropDown:Hide();
		guildOnline_PlayerInfo_Float:Show();
		ListType = guildOnline_data.guO_player_info;
		maxShown = 9;	
		for i=maxShown, self.GUILD_NUM_MEMBER_BUTTONS do
			button = getglobal("GuildMemberButton"..i);
			header = getglobal("GuildMemberHeader"..i);
			button:Hide();
			header:Hide();
		end
	else
		guildOnline_PlayerInfo_Float:Hide();
		GuildInformationDropDown:Show();
		ListType = UIDropDownMenu_GetSelectedID(GuildInformationDropDown);
		maxShown = 14;
	end
	
	if (index == nil) then
		index = 1;
	end
		
	if (go_guild_members == nil) then
		if (not go_guild_error_thrown) then
			guO_colored_echo("An error was detected, go_guild_members was nil on line 624.",1,0,0)
			go_guild_error_thrown = true;
		end
		go_guild_frame_shown = true;
		go_guild_tick_count = 0;
		self.MemberCount=0;
		local ListType = UIDropDownMenu_GetSelectedID(GuildInformationDropDown);
		for i = 1, maxShown do
			button = getglobal("GuildMemberButton"..i);
			header = getglobal("GuildMemberHeader"..i);
			if ( index <= numGuildNodes ) then
				name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle ,IsOnLine ,LogOutTime,Zone,Note= GetGuildRosterInfo(index);
				if ( isHeader ) then
					header:SetText(name);
					if ( isCollapsed ) then
						getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Plus-Up");
					else
						getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Minus-Up");
					end
					header.index = index;
					header.isCollapsed = isCollapsed;
					header:Show();
					button:Hide();
				else
					if (name~=nil) then
						self.MemberCount=	self.MemberCount+1;
						self:SetMemberList(ListType,button,name,rank, class  ,level,subClass,subLevel,guildTitle,IsOnLine,LogOutTime,Zone,Note);
					
						button.id = index;
						button.dbid=dbid;
						button.rank=rank;
						if ( index ==self: GetSelection() ) then				
							button:LockHighlight();
						else
							button:UnlockHighlight();
						end
						button:Show();
						header:Hide();
					end
				end
			else
				button:Hide();
				header:Hide();
			end
			index = index + 1;
		end
		local xx=numGuildNodes-maxShown;
		if (xx>0) then
			GuildMemberFrameScrollBar:Show();
			GuildMemberFrameScrollBar:SetMaxValue(xx);
		else
			GuildMemberFrameScrollBar:Hide();
			GuildMemberFrameScrollBar:SetMaxValue(0);
		end		
		return;
	end
	
	if (guildOnline_data ~= nil and guildOnline_data.showOnlineOnly) then
		while (shownMembers <= maxShown and index <= numGuildNodes) do
			button = getglobal("GuildMemberButton"..shownMembers);
			header = getglobal("GuildMemberHeader"..shownMembers);
			if (not (go_guild_members[index] == nil or go_guild_members[index][5] == nil)) then			
				if ( index <= numGuildNodes ) then
					name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle,IsOnLine ,LogOutTime,Zone,Note=GetGuildRosterInfo(go_guild_members[index][5]);
					if ( isHeader ) then
						header:SetText(name);
						if ( isCollapsed ) then
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Plus-Up");
						else
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Minus-Up");
						end
						header.index = go_guild_members[index][5];
						header.isCollapsed = isCollapsed;
						header:Show();
						button:Hide();
					else
						if (name~=nil) then
							if (IsOnLine) then
								self.MemberCount=self.MemberCount+1;
								shownMembers = shownMembers + 1;
								self:SetMemberList(ListType,button,name,rank, class,level,subClass,subLevel,guildTitle,IsOnLine,LogOutTime,Zone,Note,true);
							
								button.id = go_guild_members[index][5];
								button.dbid=dbid;
								button.rank=rank;
								if ( index ==self: GetSelection() ) then				
									button:LockHighlight();
								else
									button:UnlockHighlight();
								end

								if (guildOnline_data.colorCoded) then
									getglobal(button:GetName().."Name"):SetColor(guildOnline_data.rank_colors[rank][3],guildOnline_data.rank_colors[rank][4],guildOnline_data.rank_colors[rank][5]);
								end
								
								button:Show();
								header:Hide();
							end
						end
					end
				else
					button:Hide();
					header:Hide();
				end				
			end
			index = index + 1;
		end
	elseif (guildOnline_data ~= nil and guildOnline_data.useMIA) then
		index = 1;
		local skippedMembers = 1;
		local scrollBarIndex = getglobal("GuildMemberFrameScrollBar"):GetValue() + 1;
		
		while (shownMembers <= maxShown and index <= numGuildNodes) do
			button = getglobal("GuildMemberButton"..shownMembers);
			header = getglobal("GuildMemberHeader"..shownMembers);
			if (not (go_guild_members[index] == nil or go_guild_members[index][5] == nil)) then	
				if ( index <= numGuildNodes ) then
					name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle,IsOnLine ,LogOutTime,Zone,Note=GetGuildRosterInfo(go_guild_members[index][5]);
					if ( isHeader ) then
						header:SetText(name);
						if ( isCollapsed ) then
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Plus-Up");
						else
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Minus-Up");
						end
						header.index = go_guild_members[index][5];
						header.isCollapsed = isCollapsed;
						header:Show();
						button:Hide();
					else
						if (name~=nil) then
							if (IsOnLine) then
								if (skippedMembers < scrollBarIndex) then
									skippedMembers = skippedMembers + 1;
								else
									self.MemberCount=self.MemberCount+1;
									shownMembers = shownMembers + 1;
									self:SetMemberList(ListType,button,name,rank, class,level,subClass,subLevel,guildTitle,IsOnLine,LogOutTime,Zone,Note,true);
								
									button.id = go_guild_members[index][5];
									button.dbid=dbid;
									button.rank=rank;
									if ( index ==self: GetSelection() ) then				
										button:LockHighlight();
									else
										button:UnlockHighlight();
									end

									if (guildOnline_data.colorCoded) then
										getglobal(button:GetName().."Name"):SetColor(guildOnline_data.rank_colors[rank][3],guildOnline_data.rank_colors[rank][4],guildOnline_data.rank_colors[rank][5]);
									end
									button:Show();
									header:Hide();
								end
							end
						end
					end
				end
			end
			index = index + 1;
		end
		
		if (shownMembers <= maxShown and guildOnline_data.colorCoded and shownMembers > 1) then
			button = getglobal("GuildMemberButton"..shownMembers);
			getglobal(button:GetName().."Name"):SetText("----------Offline---------");
			getglobal(button:GetName().."Text"):SetText("----------Offline---------");
			getglobal(button:GetName().."Name"):SetColor(1,1,1);
			getglobal(button:GetName().."Text"):SetColor(1,1,1);
			getglobal("GuildMemberHeader"..shownMembers):Hide();
			button:Show();
			shownMembers = shownMembers + 1;
			bufferLines = bufferLines + 1;
		end
		
		index = 1;
		while (shownMembers <= maxShown and index <= numGuildNodes) do
			button = getglobal("GuildMemberButton"..shownMembers);
			header = getglobal("GuildMemberHeader"..shownMembers);
			if (not (go_guild_members[index] == nil or go_guild_members[index][5] == nil)) then	
				if ( index <= numGuildNodes ) then
					name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle,IsOnLine ,LogOutTime,Zone,Note=GetGuildRosterInfo(go_guild_members[index][5]);
					if ( isHeader ) then
						header:SetText(name);
						if ( isCollapsed ) then
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Plus-Up");
						else
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Minus-Up");
						end
						header.index = go_guild_members[index][5];
						header.isCollapsed = isCollapsed;
						header:Show();
						button:Hide();
					else
						if (name~=nil) then
							if (not IsOnLine and go_guild_members[index][6] < (guildOnline_data.miaPoint * 24)) then
								if (skippedMembers < scrollBarIndex) then
									skippedMembers = skippedMembers + 1;
								else
									self.MemberCount=self.MemberCount+1;
									shownMembers = shownMembers + 1;
									self:SetMemberList(ListType,button,name,rank, class,level,subClass,subLevel,guildTitle,IsOnLine,LogOutTime,Zone,Note,true);
								
									button.id = go_guild_members[index][5];
									button.dbid=dbid;
									button.rank=rank;
									if ( index ==self: GetSelection() ) then				
										button:LockHighlight();
									else
										button:UnlockHighlight();
									end
									
									if (guildOnline_data.colorCoded) then
										getglobal(button:GetName().."Name"):SetColor(guildOnline_data.rank_colors[rank][3],guildOnline_data.rank_colors[rank][4],guildOnline_data.rank_colors[rank][5]);
									end
									button:Show();
									header:Hide();
								end
							end
						end
					end
				end
			end
			index = index + 1;
		end
		
		if (shownMembers <= maxShown and shownMembers > 1) then
			button = getglobal("GuildMemberButton"..shownMembers);
			getglobal(button:GetName().."Name"):SetText("-----------MIA----------");
			getglobal(button:GetName().."Text"):SetText("-----------MIA----------");
			getglobal(button:GetName().."Name"):SetColor(1,1,1);
			getglobal(button:GetName().."Text"):SetColor(1,1,1);
			getglobal("GuildMemberHeader"..shownMembers):Hide();
			button:Show();
			shownMembers = shownMembers + 1;
			bufferLines = bufferLines + 1;
		end
		
		index = 1;
		while (shownMembers <= maxShown and index <= numGuildNodes) do
			button = getglobal("GuildMemberButton"..shownMembers);
			header = getglobal("GuildMemberHeader"..shownMembers);
			if (not (go_guild_members[index] == nil or go_guild_members[index][5] == nil)) then	
				if ( index <= numGuildNodes ) then
					name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle,IsOnLine ,LogOutTime,Zone,Note=GetGuildRosterInfo(go_guild_members[index][5]);
					if ( isHeader ) then
						header:SetText(name);
						if ( isCollapsed ) then
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Plus-Up");
						else
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Minus-Up");
						end
						header.index = go_guild_members[index][5];
						header.isCollapsed = isCollapsed;
						header:Show();
						button:Hide();
					else
						if (name~=nil) then
							if (not IsOnLine and go_guild_members[index][6] >= (guildOnline_data.miaPoint * 24)) then
								if (skippedMembers < scrollBarIndex) then
									skippedMembers = skippedMembers + 1;
								else
									self.MemberCount=self.MemberCount+1;
									shownMembers = shownMembers + 1;
									self:SetMemberList(ListType,button,name,rank, class,level,subClass,subLevel,guildTitle,IsOnLine,LogOutTime,Zone,Note,true);
								
									button.id = go_guild_members[index][5];
									button.dbid=dbid;
									button.rank=rank;
									if ( index ==self: GetSelection() ) then				
										button:LockHighlight();
									else
										button:UnlockHighlight();
									end
									
									if (guildOnline_data.colorCoded) then
										getglobal(button:GetName().."Name"):SetColor(guildOnline_data.rank_colors[rank][3],guildOnline_data.rank_colors[rank][4],guildOnline_data.rank_colors[rank][5]);
									end
									button:Show();
									header:Hide();
								end
							end
						end
					end
				else
					button:Hide();
					header:Hide();
				end
			end
			index = index + 1;
		end
	else
		index = 1;
		local skippedMembers = 1;
		local scrollBarIndex = getglobal("GuildMemberFrameScrollBar"):GetValue() + 1;
		
		while (shownMembers <= maxShown and index <= numGuildNodes) do
			button = getglobal("GuildMemberButton"..shownMembers);
			header = getglobal("GuildMemberHeader"..shownMembers);
			if (not (go_guild_members[index] == nil or go_guild_members[index][5] == nil)) then	
				if ( index <= numGuildNodes ) then
					name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle,IsOnLine ,LogOutTime,Zone,Note=GetGuildRosterInfo(go_guild_members[index][5]);
					if ( isHeader ) then
						header:SetText(name);
						if ( isCollapsed ) then
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Plus-Up");
						else
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Minus-Up");
						end
						header.index = go_guild_members[index][5];
						header.isCollapsed = isCollapsed;
						header:Show();
						button:Hide();
					else
						if (name~=nil) then
							if (IsOnLine) then
								if (skippedMembers < scrollBarIndex) then
									skippedMembers = skippedMembers + 1;
								else
									self.MemberCount=self.MemberCount+1;
									shownMembers = shownMembers + 1;
									self:SetMemberList(ListType,button,name,rank, class,level,subClass,subLevel,guildTitle,IsOnLine,LogOutTime,Zone,Note,true);
								
									button.id = go_guild_members[index][5];
									button.dbid=dbid;
									button.rank=rank;
									if ( index ==self: GetSelection() ) then				
										button:LockHighlight();
									else
										button:UnlockHighlight();
									end

									if (guildOnline_data.colorCoded) then
										getglobal(button:GetName().."Name"):SetColor(guildOnline_data.rank_colors[rank][3],guildOnline_data.rank_colors[rank][4],guildOnline_data.rank_colors[rank][5]);
									end
									button:Show();
									header:Hide();
								end
							end
						end
					end
				end
			end
			index = index + 1;
		end
		
		if (shownMembers <= maxShown and guildOnline_data.colorCoded and shownMembers > 1) then
			button = getglobal("GuildMemberButton"..shownMembers);
			getglobal(button:GetName().."Name"):SetText("----------Offline---------");
			getglobal(button:GetName().."Text"):SetText("--------------------------");
			getglobal(button:GetName().."Name"):SetColor(1,1,1);
			getglobal(button:GetName().."Text"):SetColor(1,1,1);
			getglobal("GuildMemberHeader"..shownMembers):Hide();
			button:Show();
			shownMembers = shownMembers + 1;
			bufferLines = bufferLines + 1;
		end
		
		index = 1;
		while (shownMembers <= maxShown and index <= numGuildNodes) do
			button = getglobal("GuildMemberButton"..shownMembers);
			header = getglobal("GuildMemberHeader"..shownMembers);
			if (not (go_guild_members[index] == nil or go_guild_members[index][5] == nil)) then	
				if ( index <= numGuildNodes ) then
					name, rank, class, level, subClass, subLevel, isHeader, isCollapsed,dbid,guildTitle,IsOnLine ,LogOutTime,Zone,Note=GetGuildRosterInfo(go_guild_members[index][5]);
					if ( isHeader ) then
						header:SetText(name);
						if ( isCollapsed ) then
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Plus-Up");
						else
							getglobal(header:GetName().."Icon"):SetTexture("Interface\\GuildFrame\\GuildNodeButton-Minus-Up");
						end
						header.index = go_guild_members[index][5];
						header.isCollapsed = isCollapsed;
						header:Show();
						button:Hide();
					else
						if (name~=nil) then
							if (not IsOnLine) then
								if (skippedMembers < scrollBarIndex) then
									skippedMembers = skippedMembers + 1;
								else
									self.MemberCount=self.MemberCount+1;
									shownMembers = shownMembers + 1;
									self:SetMemberList(ListType,button,name,rank, class,level,subClass,subLevel,guildTitle,IsOnLine,LogOutTime,Zone,Note,true);
								
									button.id = go_guild_members[index][5];
									button.dbid=dbid;
									button.rank=rank;
									if ( index ==self: GetSelection() ) then				
										button:LockHighlight();
									else
										button:UnlockHighlight();
									end
									
									if (guildOnline_data.colorCoded) then
										getglobal(button:GetName().."Name"):SetColor(guildOnline_data.rank_colors[rank][3],guildOnline_data.rank_colors[rank][4],guildOnline_data.rank_colors[rank][5]);
									end
									button:Show();
									header:Hide();
								end
							end
						end
					end
				else
					button:Hide();
					header:Hide();
				end
			end
			index = index + 1;
		end
	end
	
	for i=shownMembers, self.GUILD_NUM_MEMBER_BUTTONS do
		button = getglobal("GuildMemberButton"..i);
		header = getglobal("GuildMemberHeader"..i);
		button:Hide();
		header:Hide();
	end
	
	if (shownMembers <= maxShown) then
		GuildMemberFrameScrollBar:Hide();
		GuildMemberFrameScrollBar:SetMaxValue(0);
	else 
		local xx=numGuildNodes-maxShown + bufferLines;
		if (xx>0) then
			GuildMemberFrameScrollBar:Show();
			GuildMemberFrameScrollBar:SetMaxValue(xx);
		else
			GuildMemberFrameScrollBar:Hide();
			GuildMemberFrameScrollBar:SetMaxValue(0);
		end
		--GuildMemberFrameScrollBar:SetValue(s);
	end
end

function guO_ShowHideFloater()

end

function guildOnline_OnUpdate(this, elapsedTime)
	if (not go_guild_load_completed or go_guild_loading or not guildOnline_data.announceGuild) then return; end;
	
	go_guild_update_timer = go_guild_update_timer - elapsedTime;
	
	if (go_guild_update_timer > 0) then return; end;
	
	if (not GuildFrame:IsVisible()) then
		GuildFrame:Show();
		GuildFrame:Hide();
	end
	
	go_guild_tick_count = 0
	local lObject = GuildFrame.class;
	lObject:UpDate();
	go_guild_update_timer = 10;
end

function guildOnline_OnLoad()
	if (not vars_loaded) then	
		local curLocal = string.sub(GetLocation(), 1, 2);
		if (string.upper(curLocal) == "EN" or string.upper(curLocal) == "DE") then
			dofile("Interface/AddOns/guildOnline/Locales/guildOnline."..string.upper(curLocal)..".lua");
		else
			dofile("Interface/AddOns/guildOnline/Locales/guildOnline.EN.lua");
		end
		
		guildOnline_FloatFrame:ClearAllAnchors();
		guildOnline_FloatFrame:SetAnchor("TOPLEFT", "TOPRIGHT", GuildFrame, -45, 39);
		guO_easy_echo("guildOnline v0.13.1 "..gO_Localized["Phrases"]["Loaded"]);
		if ( AddonManager ) then
			local addon = {
				name = "guildOnline",
				description = "Toggle to only show online members",
				icon = nil,
				category = "Interface",
				configFrame = guildOnline_UIFrame,
				slashCommands = SLASH_guildOnline2,
				miniButton = nil,
				version = "0.13.1",
				author = "JJFlanigan",
			}
			if AddonManager.RegisterAddonTable then		
				AddonManager.RegisterAddonTable(addon)
			else
				AddonManager.RegisterAddon( addon.name, 
											addon.description, 
											addon.icon, 
											addon.category, 
											addon.configFrame, 
											addon.slashCommands, 
											addon.miniButton );
			end
		end
		
		color_list[1] = {1,gO_Localized["Phrases"]["Red"],.70,0,0};
		color_list[2] = {2,gO_Localized["Phrases"]["Orange"],1,.64,0};
		color_list[3] = {3,gO_Localized["Phrases"]["Yellow"],1,1,0};
		color_list[4] = {4,gO_Localized["Phrases"]["Blue"],0,0,.90};
		color_list[5] = {5,gO_Localized["Phrases"]["Green"],0,.70,0};
		color_list[6] = {6,gO_Localized["Phrases"]["Purple"],.5,0,.5};
		color_list[7] = {7,gO_Localized["Phrases"]["White"],1,1,1};
		color_list[8] = {8,gO_Localized["Phrases"]["BrightGreen"],0,1,0};
		color_list[9] = {9,gO_Localized["Phrases"]["PowderBlue"],.69,.88,.91};
		color_list[10] = {10,gO_Localized["Phrases"]["Brown"],.63,.32,.18};
		color_list[11] = {11,gO_Localized["Phrases"]["Aqua"],0,1,1};
		color_list[12] = {12,gO_Localized["Phrases"]["Teal"],0,.6,.8};
		color_list[13] = {13,gO_Localized["Phrases"]["Salmon"],.98,.8,.6};
		color_list[14] = {14,gO_Localized["Phrases"]["Olive"],.8,.8,0};
		color_list[15] = {15,gO_Localized["Phrases"]["OrangeRed"],1,.32,.0};
		
		local count=10;
		for i=1,count do
			guild_ranks[i] = GF_GetRankStr(i);
			rank_colors[i] = color_list[i];
		end
		
		SaveVariables("guildOnline_data");
		
		if (guildOnline_data == nil) then
			guildOnline_data = {};
            guildOnline_data.showOnlineOnly = guildOnline_ShowOnlineOnly_Button:IsChecked();
            guildOnline_data.colorCoded = guildOnline_ColorCoded_Button:IsChecked();
			guildOnline_data.rank_colors = rank_colors;
			guildOnline_data.guO_sort_order = 5;
			guildOnline_data.useMIA = false;
			guildOnline_data.miaPoint = 7;
			guildOnline_data.customDisplay = false;
			guildOnline_data.announceGuild = false;
			guildOnline_data.guO_player_info = 1;
			guildOnline_MIA_Point:SetText(guildOnline_data.miaPoint);
			guildOnline_UseMIA_Button:SetChecked(guildOnline_data.useMIA);
			guildOnline_ShowOnlineOnly_Button:SetChecked(guildOnline_data.showOnlineOnly);
			guildOnline_ColorCoded_Button:SetChecked(guildOnline_data.colorCoded);
			guildOnline_CustomDisplay_Button:SetChecked(guildOnline_data.customDisplay);
			guildOnline_GuildAnnounce_Button:SetChecked(guildOnline_data.announceGuild);
		else
			guildOnline_UseMIA_Button:SetChecked(guildOnline_data.useMIA);
			guildOnline_ShowOnlineOnly_Button:SetChecked(guildOnline_data.showOnlineOnly);
			guildOnline_ColorCoded_Button:SetChecked(guildOnline_data.colorCoded);
			guildOnline_CustomDisplay_Button:SetChecked(guildOnline_data.customDisplay);
			if (guildOnline_data.announceGuild == nil) then
				guildOnline_data.announceGuild = false;
				guildOnline_GuildAnnounce_Button:SetChecked(guildOnline_data.announceGuild);
			else
				guildOnline_GuildAnnounce_Button:SetChecked(guildOnline_data.announceGuild);
			end
            if (guildOnline_data.rank_colors == nil or guildOnline_data.rank_colors[4] == nil) then
				guildOnline_data.rank_colors = rank_colors;
			else
				rank_colors = guildOnline_data.rank_colors;
            end
            if (guildOnline_data.guO_sort_order == nil) then
				guildOnline_data.guO_sort_order = 5;
			end
			if (guildOnline_data.miaPoint ~= nil) then
				guildOnline_MIA_Point:SetText(guildOnline_data.miaPoint);
			else
				guildOnline_data.miaPoint = 7;
				guildOnline_MIA_Point:SetText(7);
			end
			if (guildOnline_data.guO_player_info == nil) then
				guildOnline_data.guO_player_info = 1;
			end
		end
		
		local index = 1;
		
		if (guildOnline_data.customDisplay) then
			while (index <= 14) do
				GuildInformationDropDown:Hide();
				guildOnline_PlayerInfo_Float:Show();
				getglobal("GuildMemberHeader"..index):SetHeight(26);
				getglobal("GuildMemberButton"..index):SetHeight(26);
				getglobal("GuildMemberButton"..index.."Name"):SetHeight(26);
				getglobal("GuildMemberButton"..index.."Text"):SetHeight(26);
				index = index + 1;
			end
		else
			while (index <= 14) do		
				guildOnline_PlayerInfo_Float:Hide();
				GuildInformationDropDown:Show();
				getglobal("GuildMemberHeader"..index):SetHeight(16);
				getglobal("GuildMemberButton"..index):SetHeight(16);
				getglobal("GuildMemberButton"..index.."Name"):SetHeight(16);
				getglobal("GuildMemberButton"..index.."Text"):SetHeight(16);
				index = index + 1;
			end
		end
		
		GuildFrame:Show();
		GuildFrame:Hide();
		guildOnline_LoadTimes();
		vars_loaded = true;
	end
end

SLASH_guildOnline1 = "/guildOnline";
SLASH_guildOnline2 = "/guO";

SlashCmdList["guildOnline"] = function(editBox, msg)
	if (not msg or msg == "") then
		ShowUIPanel(guildOnline_UIFrame);
		return;
	end
end